osgParticle::ExplosionOperator Class Reference

`#include <ExplosionOperator>`

Inheritance diagram for osgParticle::ExplosionOperator:

## Public Member Functions

| ExplosionOperator ()
| ExplosionOperator (const ExplosionOperator &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgParticle, ExplosionOperator)
void | setCenter (const osg::Vec3 &c)
| Set the center of shock wave.
const osg::Vec3 & | getCenter () const
| Get the center of shock wave.
void | setRadius (float r)
| Set the radius of wave peak.
float | getRadius () const
| Get the radius of wave peak.
void | setMagnitude (float mag)
| Set the acceleration scale.
float | getMagnitude () const
| Get the acceleration scale.
void | setEpsilon (float eps)
| Set the acceleration epsilon.
float | getEpsilon () const
| Get the acceleration epsilon.
void | setSigma (float s)
| Set broadness of the strength of the wave.
float | getSigma () const
| Get broadness of the strength of the wave.
void | operate (Particle *P, double dt)
| Apply the acceleration to a particle. Do not call this method manually.
void | beginOperate (Program *prg)
| Perform some initializations. Do not call this method manually.
Public Member Functions inherited from osgParticle::Operator
| Operator ()
| Operator (const Operator &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
bool | isEnabled () const
| Get whether this operator is enabled.
void | setEnabled (bool v)
| Enable or disable this operator.
virtual void | operateParticles (ParticleSystem *ps, double dt)
virtual void | endOperate ()
| Do something after all particles have been processed.
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ExplosionOperator ()
ExplosionOperator & | operator= (const ExplosionOperator &)
Protected Member Functions inherited from osgParticle::Operator
virtual | ~Operator ()
Operator & | operator= (const Operator &)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::Vec3 | _center
osg::Vec3 | _xf_center
float | _radius
float | _magnitude
float | _epsilon
float | _sigma
float | _inexp
float | _outexp
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

An explosion operator exerts force on each particle away from the explosion center. Refer to David McAllister's Particle System API (http://www.particlesystems.org)

## Constructor & Destructor Documentation

## ExplosionOperator() [1/2]

osgParticle::ExplosionOperator::ExplosionOperator | ( |  | ) |

inline

References _epsilon, _inexp, _magnitude, _outexp, _radius, _sigma, and osgParticle::Operator::Operator().

Referenced by ExplosionOperator(), META_Object(), and operator=().

## ExplosionOperator() [2/2]

osgParticle::ExplosionOperator::ExplosionOperator | ( | const ExplosionOperator & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References _center, _epsilon, _inexp, _magnitude, _outexp, _radius, _sigma, ExplosionOperator(), osgParticle::Operator::Operator(), and osg::CopyOp::SHALLOW_COPY.

## ~ExplosionOperator()

virtual osgParticle::ExplosionOperator::~ExplosionOperator | ( |  | ) |

inline protected virtual

## Member Function Documentation

## beginOperate()

void osgParticle::ExplosionOperator::beginOperate | ( | Program * | prg | ) |

inline virtual

Perform some initializations. Do not call this method manually.

Reimplemented from osgParticle::Operator.

References _center, _inexp, _outexp, _sigma, _xf_center, osgParticle::ParticleProcessor::getReferenceFrame(), osg::PI, osgParticle::ParticleProcessor::RELATIVE_RF, and osgParticle::ParticleProcessor::transformLocalToWorld().

## getCenter()

const osg::Vec3 & osgParticle::ExplosionOperator::getCenter | ( |  | ) | const

inline

Get the center of shock wave.

References _center.

## getEpsilon()

float osgParticle::ExplosionOperator::getEpsilon | ( |  | ) | const

inline

Get the acceleration epsilon.

References _epsilon.

## getMagnitude()

float osgParticle::ExplosionOperator::getMagnitude | ( |  | ) | const

inline

Get the acceleration scale.

References _magnitude.

## getRadius()

float osgParticle::ExplosionOperator::getRadius | ( |  | ) | const

inline

Get the radius of wave peak.

References _radius.

## getSigma()

float osgParticle::ExplosionOperator::getSigma | ( |  | ) | const

inline

Get broadness of the strength of the wave.

References _sigma.

## META_Object()

osgParticle::ExplosionOperator::META_Object | ( | osgParticle | ,
|  | ExplosionOperator | )

References ExplosionOperator().

## operate()

void osgParticle::ExplosionOperator::operate | ( | Particle * | P,
|  | double | dt )

inline virtual

Apply the acceleration to a particle. Do not call this method manually.

Implements osgParticle::Operator.

References _epsilon, _inexp, _magnitude, _outexp, _radius, _xf_center, osgParticle::Particle::addVelocity(), osgParticle::Particle::getPosition(), and osg::Vec3f::length().

## operator=()

ExplosionOperator & osgParticle::ExplosionOperator::operator= | ( | const ExplosionOperator & |  | ) |

inline protected

References ExplosionOperator().

## setCenter()

void osgParticle::ExplosionOperator::setCenter | ( | const osg::Vec3 & | c | ) |

inline

Set the center of shock wave.

References _center.

## setEpsilon()

void osgParticle::ExplosionOperator::setEpsilon | ( | float | eps | ) |

inline

Set the acceleration epsilon.

References _epsilon.

## setMagnitude()

void osgParticle::ExplosionOperator::setMagnitude | ( | float | mag | ) |

inline

Set the acceleration scale.

References _magnitude.

## setRadius()

void osgParticle::ExplosionOperator::setRadius | ( | float | r | ) |

inline

Set the radius of wave peak.

References _radius.

## setSigma()

void osgParticle::ExplosionOperator::setSigma | ( | float | s | ) |

inline

Set broadness of the strength of the wave.

References _sigma.

## Member Data Documentation

## _center

osg::Vec3 osgParticle::ExplosionOperator::_center

protected

Referenced by beginOperate(), ExplosionOperator(), getCenter(), and setCenter().

## _epsilon

float osgParticle::ExplosionOperator::_epsilon

protected

Referenced by ExplosionOperator(), ExplosionOperator(), getEpsilon(), operate(), and setEpsilon().

## _inexp

float osgParticle::ExplosionOperator::_inexp

protected

Referenced by beginOperate(), ExplosionOperator(), ExplosionOperator(), and operate().

## _magnitude

float osgParticle::ExplosionOperator::_magnitude

protected

Referenced by ExplosionOperator(), ExplosionOperator(), getMagnitude(), operate(), and setMagnitude().

## _outexp

float osgParticle::ExplosionOperator::_outexp

protected

Referenced by beginOperate(), ExplosionOperator(), ExplosionOperator(), and operate().

## _radius

float osgParticle::ExplosionOperator::_radius

protected

Referenced by ExplosionOperator(), ExplosionOperator(), getRadius(), operate(), and setRadius().

## _sigma

float osgParticle::ExplosionOperator::_sigma

protected

Referenced by beginOperate(), ExplosionOperator(), ExplosionOperator(), getSigma(), and setSigma().

## _xf_center

osg::Vec3 osgParticle::ExplosionOperator::_xf_center

protected

Referenced by beginOperate(), and operate().

The documentation for this class was generated from the following file:

- ExplosionOperator